# w.c.s. - web application for online forms
# Copyright (C) 2005-2010  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

import os

from quixote import get_publisher, redirect
from quixote.directory import Directory
from quixote.util import StaticDirectory

from . import errors
from . import template

class PagesDirectory(Directory):
    _q_exports = ['']

    def _q_index(self):
        return redirect('..')

    def _q_lookup(self, component):
        pages_dir = os.path.join(get_publisher().app_dir, 'pages')
        if component == 'data':
            return StaticDirectory(os.path.join(pages_dir, 'data'), follow_symlinks=True)
        page_file = os.path.join(pages_dir, component)
        if not os.path.exists(page_file):
            raise errors.TraversalError()
        content = file(page_file).read()
        template.html_top()
        return content

